<%
/*******************************************************************************
* Copyright 2009 Seapine Software, Inc. All rights reserved.
*
* IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
* in consideration of your agreement to the following terms, and your use, installation,
* modification or redistribution of this Software constitutes acceptance of these terms.
* If you do not agree with these terms, please do not use, install, modify or redistribute
* this Software.
*
* In consideration of your agreement to abide by the following terms, and subject to these
* terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
* this original Seapine software (the Software), to use, reproduce, modify and redistribute
* the Software, with or without modifications, in source and/or binary forms; provided that
* if you redistribute the Software in its entirety and without modifications, you must retain
* this notice and the following text and disclaimers in all such redistributions of the Software.
* Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
* or promote products derived from the Software without specific prior written permission from
* Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
* implied, are granted by Seapine herein, including but not limited to any patent rights that
* may be infringed by your derivative works or by other works in which the Software may be
* incorporated.
*
* The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
* EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
* OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
*
* IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
* REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
* UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
* IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************************/
%>

<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="index.aspx.cs" Inherits="Seapine_Reports_Dashboard._Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
   <title>Seapine Reports Dashboard</title>

   <link rel="shortcut icon" href="./css/images/favicon.ico">
   <link rel="stylesheet" href="css/screen.css" />

   <script type="text/javascript" src="js/jquery.js"></script>
   <script type="text/javascript" src="js/jqXMLUtils.js"></script>
   <script type="text/javascript" src="js/jquery.cookie.js"></script>
   <script type="text/javascript" src="js/treeview.js"></script>

   <script type="text/javascript">
   <!--
   -->
   </script>
   
   <script language="C#" runat="server">
      void projectChanged(Object sender, EventArgs e)
      {
         populateReportTree(ddProjects.SelectedItem.Text);
      }

      void runReport_Click(Object sender, EventArgs e) 
      {
         try
         {
            statusmsg.Text = ""; // start fresh
            CFile[] af = m_engine.runReport(ddProjects.SelectedItem.Text, Convert.ToUInt32(((LinkButton)sender).CommandName));
            if (af != null && af.Length > 0)
            {
               string strPath = HttpContext.Current.Server.MapPath(m_strCachePath);
               if (!System.IO.Directory.Exists(strPath)) { System.IO.Directory.CreateDirectory(strPath); }

               // Write the html.
               System.IO.StreamWriter sw = new System.IO.StreamWriter(System.IO.Path.Combine(strPath, af[0].mstrFileName), false);
               sw.Write(System.Text.ASCIIEncoding.ASCII.GetString(af[0].mpFileData));
               sw.Close();

               for (int i = 1; i < af.Length; ++i)
               {  // Write the images.
                  System.IO.FileStream fs = System.IO.File.Create(System.IO.Path.Combine(strPath, af[i].mstrFileName));
                  System.IO.BinaryWriter bw = new System.IO.BinaryWriter(fs);
                  bw.Write(af[i].mpFileData);
                  bw.Close();
                  fs.Close();
               }

               // hard to know on height here. 900 should work for majority of business folk, except those down at 1024.
               maincontent.InnerHtml = "<object data=\"" + m_strCachePath + "/" + af[0].mstrFileName + "\" width=\"100%\" height=\"900\"></object>";
            }
            else
               statusmsg.Text = m_engine.lastError();
         }
         catch(Exception p_exception) { Response.Write("Save Run Results: " + p_exception.Message); }
      }
   </script>
   
</head>
<body>
   <form id="Form1" runat="server">
      <div id="main">

         <div id="maincontent" runat="server"><asp:Label ID="statusmsg" runat="server" ForeColor="Red" /></div>

         <div class="obox">
            <table class="obox_top" cellpadding="0" cellspacing="0"><tr>
               <td style="width: 17px; height: 17px; background: url(css/images/corner_outside_top_left.png) no-repeat; ">&nbsp;</td>
               <td style="background: url(css/images/corner_outside_top_border.png) repeat-x; ">&nbsp;</td>
               <td style="width: 17px; height: 17px; background: url(css/images/corner_outside_top_right.png) no-repeat; ">&nbsp;</td>
            </tr></table>

            <div id="sidetree" style="margin-top:-1px;">
               <div class="treeheader">&nbsp;</div>

               <div id="prjdd">
                  <asp:DropDownList ID="ddProjects" Width="100%" AutoPostBack="True" OnSelectedIndexChanged="projectChanged" runat="server" />
               </div>
            
               <div id="sidetreecontrol"><a href="javascript:collapseAll();">Collapse All</a> | <a href="javascript:expandAll();">Expand All</a></div>

               <div class="ibox">
                  <table class="ibox_top" cellpadding="0" cellspacing="0"><tr>
                     <td style="width: 12px; height: 12px; background: url(css/images/corner_inside_top_left.png) no-repeat; ">&nbsp;</td>
                     <td Style="background: url(css/images/corner_inside_top_border.png) repeat-x; ">&nbsp;</td>
                     <td style="width: 12px; height: 12px; background: url(css/images/corner_inside_top_right.png) no-repeat; ">&nbsp;</td>
                  </tr></table>

               <div id="treectrl">
                  <ul id="tree">

                     <li id="tlhdrdefects" class="Expanded" runat="server"><span class="defects"></span><span class="reportgroup"><asp:Label ID="lDefectIcon" runat="server">Defects</asp:Label></span>
                        <ul id="tdefects" runat="server">
                           <asp:Repeater ID="repeaterDefects" runat="server">
                              <ItemTemplate>
                                 <li class="reportlink">
                                    <asp:LinkButton id=LinkButton1 OnClick="runReport_Click" CommandName=<%# DataBinder.Eval(Container.DataItem, "Id" ) %> runat="server">
                                    <%# DataBinder.Eval(Container.DataItem, "Name" ).ToString() %>
                                    </asp:LinkButton>
                                 </li>
                              </ItemTemplate>
                           </asp:Repeater>
                        </ul>
                     </li>

                     <li id="tlhdrtestcases" class="Expanded" runat="server"><span class="testcases"></span><span class="reportgroup"><asp:Label ID="lTestCaseIcon" runat="server">Test Cases</asp:Label></span>
                        <ul id="ttestcases" runat="server">
                           <asp:Repeater ID="repeaterTestCases" runat="server">
                              <ItemTemplate>
                                 <li class="reportlink">
                                    <asp:LinkButton id=LinkButton1  OnClick="runReport_Click" CommandName=<%# DataBinder.Eval(Container.DataItem, "Id" ) %> runat="server">
                                       <%# DataBinder.Eval(Container.DataItem, "Name" ).ToString() %>
                                    </asp:LinkButton>
                                 </li>
                              </ItemTemplate>
                           </asp:Repeater>
                        </ul>
                     </li>

                     <li id="tlhdrtestruns" class="Expanded" runat="server"><span class="testruns"></span><span class="reportgroup"><asp:Label ID="lTestRunIcon" runat="server">Test Runs</asp:Label></span>
                        <ul id="ttestruns" runat="server">
                           <asp:Repeater ID="repeaterTestRuns" runat="server">
                              <ItemTemplate>
                                 <li class="reportlink">
                                    <asp:LinkButton id=LinkButton1 OnClick="runReport_Click" CommandName=<%# DataBinder.Eval(Container.DataItem, "Id" ) %> runat="server">
                                       <%# DataBinder.Eval(Container.DataItem, "Name" ).ToString() %>
                                    </asp:LinkButton>
                                 </li>
                              </ItemTemplate>
                           </asp:Repeater>
                        </ul>
                     </li>

                     <li id="tlhdrrequirements" class="Expanded" runat="server"><span class="requirements"></span><span class="reportgroup"><asp:Label ID="lRequirementIcon" runat="server">Requirements</asp:Label></span>
                        <ul id="trequirements" runat="server">
                           <asp:Repeater ID="repeaterRequirements" runat="server">
                              <ItemTemplate>
                                 <li class="reportlink">
                                    <asp:LinkButton id="LinkButton1" OnClick="runReport_Click" CommandName=<%# DataBinder.Eval(Container.DataItem, "Id" ) %> runat="server">
                                       <%# DataBinder.Eval(Container.DataItem, "Name" ).ToString() %>
                                    </asp:LinkButton>
                                 </li>
                              </ItemTemplate>
                           </asp:Repeater>
                        </ul>
                     </li>

                     <li id="tlhdrrequirementdocuments" class="Expanded" runat="server"><span class="requirementdocuments"></span><span class="reportgroup"><asp:Label ID="lRequirementDocumentIcon" runat="server">Requirement Documents</asp:Label></span>
                        <ul id="trequirementdocuments" runat="server">
                           <asp:Repeater ID="repeaterRequirementDocuments" runat="server">
                              <ItemTemplate>
                                 <li class="reportlink">
                                    <asp:LinkButton id="LinkButton1" OnClick="runReport_Click" CommandName=<%# DataBinder.Eval(Container.DataItem, "Id" ) %> runat="server">
                                       <%# DataBinder.Eval(Container.DataItem, "Name" ).ToString() %>
                                    </asp:LinkButton>
                                 </li>
                              </ItemTemplate>
                           </asp:Repeater>
                        </ul>
                     </li>

                  </ul>

               </div>
            </div>
         </div>
         </div>
      </div>
   </form>

   <script type="text/javascript" language="javascript">
      SetupTreeView("tree");
   </script>

</body>
</html>
