// Courtesy of: http://www.ridgway.co.za/archive/2005/10/30/asimplecssbasedtreeview.aspx
// Toggles between two classes for an element
Array.prototype.indexOf = IndexOf;

function ToggleClass(element, firstClass, secondClass, event)
{
   event.cancelBubble = true;

   var classes = element.className.split(" ");
   var firstClassIndex = classes.indexOf(firstClass);
   var secondClassIndex = classes.indexOf(secondClass);

   if (firstClassIndex == -1 && secondClassIndex == -1)
   {
      classes[classes.length] = firstClass;
   }
   else if (firstClassIndex != -1)
   {
      classes[firstClassIndex] = secondClass;
   }
   else
   {
      classes[secondClassIndex] = firstClass;
   }
   element.className = classes.join(" ");
}

//Finds the index of an item in an array
function IndexOf(item)
{
   for (var i=0; i < this.length; i++)
   {
      if (this[i] == item)
      {
         return i;
      }
      }
   return -1;
} 

// The toggle event handler for each expandable/collapsable node
// - Note that this also exists to prevent any IE memory leaks
// (due to circular references caused by this)
function ToggleNodeStateHandler(event)
{
   ToggleClass(this.parentNode, "Collapsed", "Expanded", (event == null) ? window.event : event);
}

//Prevents the onclick event from bubbling up to parent elements
function PreventBubbleHandler(event)
{
   if (!event) event = window.event;
      event.cancelBubble = true;
}

//Adds the relevant onclick handlers for the nodes in the tree view
function SetupTreeView(elementId)
{
   var tree = document.getElementById(elementId);
   var treeElements = tree.getElementsByTagName("li");

   for (var i=0; i < treeElements.length; i++)
   {
      if (treeElements[i].getElementsByTagName("ul").length > 0)
      {
         treeElements[i].getElementsByTagName("span")[0].onclick = ToggleNodeStateHandler;
      }
      else
      {
// /* throws exception in IE */       treeElements[i].getElementsByTagName("span")[0].onclick = PreventBubbleHandler;
      }
   }
} 

function collapseAll()
{
   var treeElements = document.getElementById("tree").getElementsByTagName("li");
   for (var i=0; i < treeElements.length; i++)
   {
      var element = treeElements[i];
      var classes = element.className.split(" ");

      var firstClassIndex = classes.indexOf("Expanded");
      var secondClassIndex = classes.indexOf("Collapsed");

      if (firstClassIndex == -1 && secondClassIndex == -1)
      {  // neither found, so mark it as collapsed
         classes[classes.length] = "Collapsed";
      }
      else if (firstClassIndex != -1)
      {  // expanded, so collapse it
         classes[firstClassIndex] = "Collapsed";
      }
      element.className = classes.join(" ");
   }
}

function expandAll()
{
   var treeElements = document.getElementById("tree").getElementsByTagName("li");
   for (var i=0; i < treeElements.length; i++)
   {
      var element = treeElements[i];
      var classes = element.className.split(" ");

      var firstClassIndex = classes.indexOf("Collapsed");
      var secondClassIndex = classes.indexOf("Expanded");

      if (firstClassIndex == -1 && secondClassIndex == -1)
      {  // neither found, so mark it as collapsed
         classes[classes.length] = "Expanded";
      }
      else if (firstClassIndex != -1)
      {  // expanded, so collapse it
         classes[firstClassIndex] = "Expanded";
      }
      element.className = classes.join(" ");
   }
}