<?php
/*******************************************************************************
* Copyright 2009 Seapine Software, Inc. All rights reserved.
*
* IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (“Seapine”)
* in consideration of your agreement to the following terms, and your use, installation,
* modification or redistribution of this Software constitutes acceptance of these terms.
* If you do not agree with these terms, please do not use, install, modify or redistribute
* this Software.
*
* In consideration of your agreement to abide by the following terms, and subject to these
* terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
* this original Seapine software (the "Software"), to use, reproduce, modify and redistribute
* the Software, with or without modifications, in source and/or binary forms; provided that
* if you redistribute the Software in its entirety and without modifications, you must retain
* this notice and the following text and disclaimers in all such redistributions of the Software.
* Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
* or promote products derived from the Software without specific prior written permission from
* Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
* implied, are granted by Seapine herein, including but not limited to any patent rights that
* may be infringed by your derivative works or by other works in which the Software may be
* incorporated.
*
* The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
* EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
* OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
*
* IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
* REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
* UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
* IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************************/

   // find an array element the hard way.
   function VariableArray($arr, $string)
   {  // Courtesy of http://ca.php.net/manual/en/language.variables.variable.php#87564
      preg_match_all('/\[([^\]]*)\]/', $string, $arr_matches, PREG_PATTERN_ORDER);
      $return = $arr;
      foreach($arr_matches[1] as $dimension) { $return = $return[$dimension]; }
      return $return;
   }

   $strUsr = "administrator";
   $strPwd = "";
   $strCachePath = "temp/";
   $strRepDisplayPath = "";

   // if you've renamed any of the core object types, then specify the new label here.
   $labelDefectType = "Defects";
   $labelTestCaseType = "Test Cases";
   $labelTestRunType = "Test Runs";
   $labelRequirementType = "Requirements";
   $labelRequirementDocumentType = "Requirement Documents";

   $aDefectReports = array();
   $aTCReports = array();
   $aTRReports = array();
   $aRQReports = array();
   $aRDReports = array();

   try
   {
      $client = new SoapClient('http://127.0.0.1/ttsoapcgi.wsdl', array('location' => "http://127.0.0.1/cgi-bin/ttsoapcgi.exe",
                                                                        'uri'      => "urn:testtrack-interface/") );
      $client->soap_defencoding = 'UTF-8';

      $strSelectPrj = "";
      if (array_key_exists("prj", $_REQUEST)) { $strSelectPrj = $_REQUEST['prj']; }

      // easier to fetch then find the CProject than trying to create one.
      $aprj = $client->getProjectList($strUsr, $strPwd);

      $prj = $aprj[0]; // default to the first one!
      for ($i = 0; $i < count($aprj); ++$i)
      {
         if ($aprj[$i]->database->name == $strSelectPrj) { $prj = $aprj[$i]; break; }
      }

      $sessionId = $client->ProjectLogon($prj, $strUsr, $strPwd);
      if (strlen($sessionId) > 0)
      {
         try
         {
            $report = $client->getRecordListForTable($sessionId, "Report", "", ""); // would be more future-friendly and efficient to hard-code the columns we care about.
            // print_r($areport);

            for ($i = 0; $i < count($report->records); ++$i)
            {  // what is report Contains?
               if ($report->records[$i]->row[5]->value == $labelDefectType)
                  $aDefectReports[] = $report->records[$i]->row[0]->value;
               else if ($report->records[$i]->row[5]->value == $labelTestCaseType)
                  $aTCReports[] = $report->records[$i]->row[0]->value;
               else if ($report->records[$i]->row[5]->value == $labelTestRunType)
                  $aTRReports[] = $report->records[$i]->row[0]->value;
               else if ($report->records[$i]->row[5]->value == $labelRequirementType)
                  $aRQReports[] = $report->records[$i]->row[0]->value;
               else if ($report->records[$i]->row[5]->value == $labelRequirementDocumentType)
                  $aRDReports[] = $report->records[$i]->row[0]->value;
            }

            if (array_key_exists("name", $_REQUEST) && strlen($_REQUEST["name"])>0)
            {
               try { if (!is_dir($strCachePath)) { mkdir($strCachePath); } } catch(Exception $e) {}
               
               $reportrun = $client->getReportRunResultsByName($sessionId, $_REQUEST["name"]);
               $strRepDisplayPath = ""; // reset

               // PHP doesn't like a '-' in func/variable names so you can't access m-FileList directly.
               // Here we convert to array then pass it to our handy-dandy func to find the hard way.
               $arunresults = VariableArray(get_object_vars($reportrun), "[m-FileList]");

               for ($i = 0; $i < count($arunresults); ++$i)
               {
                  // first element is the html, we need to keep that path to display it later.
                  if (strlen($strRepDisplayPath) == 0) { $strRepDisplayPath = $strCachePath . VariableArray(get_object_vars($arunresults[$i]), "[m-strFileName]"); }

                  // Create/clear the file we need to write to.
                  $f = fopen($strCachePath . VariableArray(get_object_vars($arunresults[$i]), "[m-strFileName]"), "w+");
                  fwrite($f, VariableArray(get_object_vars($arunresults[$i]), "[m-pFileData]"));
               }
            }
         } catch (Exception $e) { echo 'Reporting exception: ',  $e->getMessage(), "\n"; }

         $client->DatabaseLogoff($sessionId);
         $sessionId = 0;
      }
   } catch (Exception $e) { echo 'ProjectLogon exception: ',  $e->getMessage(), "\n"; }
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
   <head>
      <title>Seapine Reports Dashboard</title>

      <link rel="shortcut icon" href="./css/images/favicon.ico">
      <link rel="stylesheet" href="css/screen.css" />

      <style type="text/css">
      </style>

      <script type="text/javascript" src="js/treeview.js"></script>
      <script type="text/javascript">
      <!--
         // $().ajaxSend(function(r,s){ $("#loading").show(); });  
         // $().ajaxStop(function(r,s){ $("#loading").fadeOut("fast"); });
      -->
      </script>
   </head>

   <body>
      <div id="loading" class="loading" style="display:none;">
         <!-- Padding the image in the css ends up forcing the page off-screen (i.e. vert scroll bar shows temporarily) -->
         <br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />
         <img src="css/images/loading.gif" alt="patientce, grasshopper...">
      </div>

      <div id="main">

         <div id="maincontent">
            <?php
               if (strlen($strRepDisplayPath) > 0) // if report path is not empty, then we need to display it!
                  echo "<object data=\"" . $strRepDisplayPath . "\" width=\"100%\" height=\"900\">";
            ?>
         </div>

         <div class="obox">
            <table class="obox_top" cellpadding="0" cellspacing="0"><tr>
               <td style="width: 17px; height: 17px; background: url(css/images/corner_outside_top_left.png) no-repeat; ">&nbsp;</td>
               <td style="background: url(css/images/corner_outside_top_border.png) repeat-x; ">&nbsp;</td>
               <td style="width: 17px; height: 17px; background: url(css/images/corner_outside_top_right.png) no-repeat; ">&nbsp;</td>
            </tr></table>

            <div id="sidetree" >
               <div class="treeheader">&nbsp;</div>

               <form id="fProjects" name="fProjects" method="post" action="index.php" method="post">
                  <?php
                     echo "<select name=\"prj\" id=\"ddProjects\" onchange=\"this.form.submit()\" style=\"width:100%;\">";

                     $aprj = $client->getProjectList($strUsr, $strPwd);
                     for ($i = 0; $i < count($aprj); ++$i)
                        echo '<option ' . (($strSelectPrj == $aprj[$i]->database->name)?'selected':'') . ' value="' . $aprj[$i]->database->name . '">' . $aprj[$i]->database->name . '</option>';
                     echo '</select>';
                  ?>
               </form>

               <div id="sidetreecontrol"><a href="javascript:collapseAll();">Collapse All</a> | <a href="javascript:expandAll();">Expand All</a></div>

               <div class="ibox">
                  <table class="ibox_top" cellpadding="0" cellspacing="0"><tr>
                     <td style="width: 12px; height: 12px; background: url(css/images/corner_inside_top_left.png) no-repeat; ">&nbsp;</td>
                     <td Style="background: url(css/images/corner_inside_top_border.png) repeat-x; ">&nbsp;</td>
                     <td style="width: 12px; height: 12px; background: url(css/images/corner_inside_top_right.png) no-repeat; ">&nbsp;</td>
                  </tr></table>

                  <div id="treectrl">

                     <ul id="tree" class="tree">

                        <?php if (count($aDefectReports) > 0) { ?>
                        <li class="Expanded"><span class="defects"></span><span class="reportgroup"><?php echo $labelDefectType; ?></span>
                           <ul id="tree-d">
                              <?php
                                 for ($i = 0; $i < count($aDefectReports); ++$i)
                                    echo "<li class=\"reportlink\"><a href=\"?prj=" . urlencode($strSelectPrj) . "&name=" . urlencode($aDefectReports[$i]) . "\">" . $aDefectReports[$i] . "</a></li>";
                              ?>
                           </ul>
                        </li>
                        <?php } ?>

                        <?php if (count($aTCReports) > 0) { ?>
                        <li class="Expanded"><span class="testcases"></span><span class="reportgroup"><?php echo $labelTestCaseType; ?></span>
                           <ul id="tree-tc">
                              <?php
                                 for ($i = 0; $i < count($aTCReports); ++$i)
                                    echo "<li class=\"reportlink\"><a href=\"?prj=" . urlencode($strSelectPrj) . "&name=" . urlencode($aTCReports[$i]) . "\">" . $aTCReports[$i] . "</a></li>";
                              ?>
                           </ul>
                        </li>
                        <?php } ?>

                        <?php if (count($aTRReports) > 0) { ?>
                        <li class="Expanded"><span class="testruns"></span><span class="reportgroup"><?php echo $labelTestRunType; ?></span>
                           <ul id="tree-tr">
                              <?php
                                 for ($i = 0; $i < count($aTRReports); ++$i)
                                    echo "<li class=\"reportlink\"><a href=\"?prj=" . urlencode($strSelectPrj) . "&name=" . urlencode($aTRReports[$i]) . "\">" . $aTRReports[$i] . "</a></li>";
                              ?>
                           </ul>
                        </li>
                        <?php } ?>

                        <?php if (count($aRQReports) > 0) { ?>
                        <li class="Expanded"><span class="requirements"></span><span class="reportgroup"><?php echo $labelRequirementType; ?></span>
                           <ul id="tree-rq">
                              <?php
                                 for ($i = 0; $i < count($aRQReports); ++$i)
                                    echo "<li class=\"reportlink\"><a href=\"?prj=" . urlencode($strSelectPrj) . "&name=" . urlencode($aRQReports[$i]) . "\">" . $aRQReports[$i] . "</a></li>";
                              ?>
                           </ul>
                        </li>
                        <?php } ?>

                        <?php if (count($aRDReports) > 0) { ?>
                        <li class="Expanded"><span class="requirementdocuments"></span><span class="reportgroup"><?php echo $labelRequirementDocumentType; ?></span>
                           <ul id="tree-rd">
                              <?php
                                 for ($i = 0; $i < count($aRDReports); ++$i)
                                    echo "<li class=\"reportlink\"><a href=\"?prj=" . urlencode($strSelectPrj) . "&name=" . urlencode($aRDReports[$i]) . "\">" . $aRDReports[$i] . "</a></li>";
                              ?>
                           </ul>
                        </li>
                        <?php } ?>

                     </ul>

                  </div>
               </div>
            </div>
         </div>

      </div>

      <script type="text/javascript" language="javascript">
         SetupTreeView("tree");
      </script>

   </body>
</html>
